/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.sortlistofpairsexamples;

import org.apache.commons.lang3.tuple.Pair;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import java.util.Comparator;

/**
 *
 * @author omozegieaziegbe
 */
public class StreamsWordFrequencySorter {
   
    // List to store words and their frequencies
    private final List<Pair<String, Integer>> words = new ArrayList<>();

    // Add sample word-frequency pairs to the list
    public void addWords() {
        words.add(Pair.of("apple", 54));
        words.add(Pair.of("banana", 27));
        words.add(Pair.of("orange", 86));
        words.add(Pair.of("grape", 39));
        words.add(Pair.of("pineapple", 10));
    }
    

    // Sort the list using Streams and a lambda expression
    public List<Pair<String, Integer>> sortWordsByFrequencyUsingStreams() {
        return words.stream()
                .sorted(Comparator.comparing(Pair::getRight))
                .collect(Collectors.toList());
    }

    // Print the sorted list of words
    public void printSortedWords(List<Pair<String, Integer>> sortedWords) {
        for (Pair<String, Integer> pair : sortedWords) {
            System.out.println(pair.getLeft() + ": " + pair.getRight());
        }
    }

    public static void main(String[] args) {
        StreamsWordFrequencySorter sorter = new StreamsWordFrequencySorter();
        sorter.addWords();

        // Sort using Streams
        List<Pair<String, Integer>> sortedList = sorter.sortWordsByFrequencyUsingStreams();
        sorter.printSortedWords(sortedList);
    }
}
