/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.sortlistofpairsexamples;

import java.util.ArrayList;
import java.util.List;
import org.apache.commons.lang3.tuple.Pair;
import java.util.Collections;
import java.util.Comparator;

/**
 *
 * @author omozegieaziegbe
 */
public class WordFrequencySorter {
    
    // List to store words and their frequencies
    private final List<Pair<String, Integer>> words = new ArrayList<>();

    // Add sample word-frequency pairs to the list
    public void addWords() {
        words.add(Pair.of("travel", 50));
        words.add(Pair.of("photography", 40));
        words.add(Pair.of("adventure", 30));
        words.add(Pair.of("lifestyle", 20));
        words.add(Pair.of("culture", 15));
    }

    public List<Pair<String, Integer>> getWords() {
        return words;
    }
    
    // Sort the list using Collections.sort() and a lambda expression
    public void sortWordsByFrequencyUsingLambda() {
        Collections.sort(words, Comparator.comparing(p -> -p.getRight()));
    }

    // Print the sorted list of words
    public void printSortedWords() {
        for (Pair<String, Integer> pair : words) {
            System.out.println(pair.getLeft() + ": " + pair.getRight());
        }
    }

    public static void main(String[] args) {
        WordFrequencySorter sorter = new WordFrequencySorter();
        sorter.addWords();
        sorter.sortWordsByFrequencyUsingLambda();
        sorter.printSortedWords();
    }
    
}
